/**********************************************************************
 *	[XŌASY.
 **********************************************************************
 *	uchar morse_stat()
 *	void morse_send(uchar c)
 *	void morse_task()
 */
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>

#include "config.h"
#include "task.h"
#include "timer.h"
#include "morse.h"
#include "sound.h"


#include "morsetab.h"	//\.


//	AZ̒萔.
#define	MORSE_SPEED1	32
#define	MORSE_SPEED3	(MORSE_SPEED1*3+4)	//̊A.


//	ԕϐ:
uchar morse_char;	// ASCII CODE
uchar morse_pat;	// pattern (MSB morse_cnt rbgL)
					// bit0Ȃ璷,1ȂZ.

uchar morse_cnt;	// counter (1..5܂ŁA0ȂŌI)
uchar morse_sub;	// sub count 0:mark 1:space 2:end of job

void  keyon(uchar c)
{
	if(c) {
		sound_play(0,0x280,0xff);
	}else{
		sound_play(0,0,0);
	}
}

/**********************************************************************
 *	
 **********************************************************************
 */
void morse_init(void)
{
	TX_OUT_PORT |= TX_OUT_BIT_MASK;	// PD7H.
//	TX_OUT_DDR  |= TX_OUT_BIT_MASK;	// PD7out.
}

/**********************************************************************
 *	.(CW U)
 **********************************************************************
 */
static	void morse_out_mark(void)
{
	TX_OUT_PORT &= ~TX_OUT_BIT_MASK;	// PD7L.(dgon)
	TX_OUT_DDR  |= TX_OUT_BIT_MASK;		// PD7out.
	keyon(1);							//TEh[`On.
}
/**********************************************************************
 *	𗣂.(CW ~)
 **********************************************************************
 */
static	void morse_out_space(void)
{
	TX_OUT_DDR  &= ~TX_OUT_BIT_MASK;	// PD7in.
	TX_OUT_PORT |= TX_OUT_BIT_MASK;		// PD7H.(pull up)
	keyon(0);							//TEh[`Off.
}

/**********************************************************************
 *	R}ĥ̉ۂԂ.
 **********************************************************************
 *	߂l :
 *		0  : R}ht\.
 *	   !0  : ݑŌASCII (1)
 */
uchar morse_stat(void)
{
	return morse_char;
}

/**********************************************************************
 *	R}h̏ sub.
 **********************************************************************
 *	c = Ō ASCIIR[h .
 *	i = ŌR[h̃e[uԍ.(Alphabet 26 + Numeric 10 ̂ǂꂩ)
 */
static void morse_send_idx(uchar c,uchar i)
{
	uchar d = __LPM(&morse_tab[i]);
	morse_char = c;
	morse_pat = d;
	morse_cnt = d & 7;
	morse_sub = 0;
}
/**********************************************************************
 *	R}h̏.
 **********************************************************************
 *	c = Ō ASCIIR[h .
 */
void morse_send(uchar c)
{
	if((c>='A')&&(c<='Z')) {morse_send_idx(c,c-'A'   );return;}
	if((c>='a')&&(c<='z')) {morse_send_idx(c,c-'a'   );return;}
	if((c>='0')&&(c<='9')) {morse_send_idx(c,c-'0'+26);return;}
	if((c==' ')) {morse_send_idx(c,'e'-'a');return;}
}

/**********************************************************************
 *	̋NԂZbg.
 **********************************************************************
 *	len = 0   ҂.
 *	len !=0   Z҂.
 */
void sleep_key(uchar len)
{
	uchar    c;
	if(!len){c = MORSE_SPEED3;}
	else	{c = MORSE_SPEED1;}

	sleep_tsk(c << 5);
}
/**********************************************************************
 *	[XŌ^XN.
 **********************************************************************
 */
void morse_task(void)
{
	uchar keylen;
	if(morse_char==0) return;	//Ō:

	switch(morse_sub) {	//TuV[PXɂ蕪򏈗:
	 case 0:	// KEY_ON ==========
		keylen= morse_pat & 0x80; 	//Ōp^[.Ȃ0AZȂ1.
				morse_pat<<=1; 		//Ōp^[PVtg.
				morse_cnt--;		//ŌP.

		if(morse_char != ' ') {		//󔒈ȊO.
			morse_out_mark();		//L[.
		}

		morse_sub = 1;				//V[PXɈڍs.
		sleep_key(keylen);			//N܂ł̑҂ԃZbg.
	 	break;
	 case 1:	// KEY_OFF ========
		morse_out_space();			//L[.

		morse_sub = 2;				//V[PXɈڍs.
		sleep_key(1);
	 	break;
	 case 2:	// STOP BIT =======
		if(	morse_cnt == 0 ) {		//SŌ?
			morse_sub = 3;			//V[PXɈڍs.
			sleep_key(0);			//N܂ł̑҂ԃZbg.
		}else{
			morse_sub=0;			//V[PXEZbg.
		}
	 	break;
	 default:
	 case 3:	// JOB END ========	ŌI.
		morse_sub = 0;
		morse_char = 0;				//̑Ōt\ɂ.
	 	break;
	}
}
/**********************************************************************
 *	
 **********************************************************************
 */
